<template>
  <div>
    <div v-if="$auth.loggedIn" :class="dropdownOpened ? 'z-30' : 'z-0'" class="dropdown-nav relative py-4" @click="dropDownClickHandler" @mouseenter="mouseenter" @mouseleave="mlAccountNotlogged">
      <a href="#">
        <div class="flex items-center flex-row h-full">
          <div class="rounded-full flex items-center justify-center border-2 w-10 h-10 border-white">
            <svg fill="currentColor" class="fill-current text-white inline-block h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20">
              <path class="heroicon-ui" d="M5 5a5 5 0 0 1 10 0v2A5 5 0 0 1 5 7V5zM0 16.68A19.9 19.9 0 0 1 10 14c3.64 0 7.06.97 10 2.68V20H0v-3.32z"/>
            </svg>
          </div>
          <div class="hidden md:hidden lg:flex lg:flex-row w-40 pl-2">

              <span class="text-sm font-light leading-tight text-left text-white">
                olá, {{ $auth.user.name }} minha conta
              </span>
              <svg class="h-6 w-6 text-white font-light" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor">
                <path d="M5.293 7.293a1 1 0 011.414 0L10 10.586l3.293-3.293a1 1 0 111.414 1.414l-4 4a1 1 0 01-1.414 0l-4-4a1 1 0 010-1.414z" clip-rule="evenodd" />
              </svg>
            </div>
        </div>
      </a>
      <transition name="fade">
      <div v-show="dropdownOpened" class="absolute dropdown-nav-content lg:left-0 lg:ml-0 -ml-40 mt-4">
        <div class="flex flex-column">
          <div class="bg-white h-8 w-6 -mt-4 lg:-mt-5 mx-40 pl-2 bg-opacity-0">
            <svg fill="currentColor" class=" text-white h-4 top-full" x="0px" y="0px" viewBox="0 0 300 200" xml:space="preserve"><polygon class="fill-current stroke-0" points="150,0 300,200 0,200"/></svg>
          </div>
            <ul class="normal-case font-normal absolute xs:left-0 bg-white shadow overflow-hidden w-56 -mt-1">
              <li>
                <a href="#" ref="account" class="flex items-center px-3 py-3 hover:bg-gray-200">
                  <svg fill="currentColor" class="text-gray-600" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24"><path class="heroicon-ui" d="M12 12a5 5 0 1 1 0-10 5 5 0 0 1 0 10zm0-2a3 3 0 1 0 0-6 3 3 0 0 0 0 6zm9 11a1 1 0 0 1-2 0v-2a3 3 0 0 0-3-3H8a3 3 0 0 0-3 3v2a1 1 0 0 1-2 0v-2a5 5 0 0 1 5-5h8a5 5 0 0 1 5 5v2z"></path></svg>
                  <span class="ml-2 text-sm">minha conta</span>
                </a>
              </li>
              <li>
                <a href="#" class="flex items-center px-3 py-3 hover:bg-gray-200">
                  <svg fill="currentColor" class="text-gray-600" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24"><path class="heroicon-ui" d="M12 22a10 10 0 1 1 0-20 10 10 0 0 1 0 20zm0-2a8 8 0 1 0 0-16 8 8 0 0 0 0 16zm1-11v2h1a3 3 0 0 1 0 6h-1v1a1 1 0 0 1-2 0v-1H8a1 1 0 0 1 0-2h3v-2h-1a3 3 0 0 1 0-6h1V6a1 1 0 0 1 2 0v1h3a1 1 0 0 1 0 2h-3zm-2 0h-1a1 1 0 1 0 0 2h1V9zm2 6h1a1 1 0 0 0 0-2h-1v2z"></path></svg>
                  <span class="ml-2 text-sm">endereços</span>
                </a>
              </li>
              <li class="border-b border-gray-400">
                <nuxt-link :to="localePath({ name: 'orders' })" class="flex items-center px-3 py-3 hover:bg-gray-200">
                  <svg fill="currentColor" class="text-gray-600" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24"><path class="heroicon-ui" d="M9 4.58V4c0-1.1.9-2 2-2h2a2 2 0 0 1 2 2v.58a8 8 0 0 1 1.92 1.11l.5-.29a2 2 0 0 1 2.74.73l1 1.74a2 2 0 0 1-.73 2.73l-.5.29a8.06 8.06 0 0 1 0 2.22l.5.3a2 2 0 0 1 .73 2.72l-1 1.74a2 2 0 0 1-2.73.73l-.5-.3A8 8 0 0 1 15 19.43V20a2 2 0 0 1-2 2h-2a2 2 0 0 1-2-2v-.58a8 8 0 0 1-1.92-1.11l-.5.29a2 2 0 0 1-2.74-.73l-1-1.74a2 2 0 0 1 .73-2.73l.5-.29a8.06 8.06 0 0 1 0-2.22l-.5-.3a2 2 0 0 1-.73-2.72l1-1.74a2 2 0 0 1 2.73-.73l.5.3A8 8 0 0 1 9 4.57zM7.88 7.64l-.54.51-1.77-1.02-1 1.74 1.76 1.01-.17.73a6.02 6.02 0 0 0 0 2.78l.17.73-1.76 1.01 1 1.74 1.77-1.02.54.51a6 6 0 0 0 2.4 1.4l.72.2V20h2v-2.04l.71-.2a6 6 0 0 0 2.41-1.4l.54-.51 1.77 1.02 1-1.74-1.76-1.01.17-.73a6.02 6.02 0 0 0 0-2.78l-.17-.73 1.76-1.01-1-1.74-1.77 1.02-.54-.51a6 6 0 0 0-2.4-1.4l-.72-.2V4h-2v2.04l-.71.2a6 6 0 0 0-2.41 1.4zM12 16a4 4 0 1 1 0-8 4 4 0 0 1 0 8zm0-2a2 2 0 1 0 0-4 2 2 0 0 0 0 4z"></path></svg>
                  <span class="ml-2 text-sm">meus pedidos</span>
                </nuxt-link>
              </li>
              <li>
                <a href="#" class="flex items-center px-3 py-3 hover:bg-gray-200" @click="logout">
                  <svg fill="currentColor" class="text-gray-600" xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M0 0h24v24H0z" fill="none"></path><path d="M10.09 15.59L11.5 17l5-5-5-5-1.41 1.41L12.67 11H3v2h9.67l-2.58 2.59zM19 3H5c-1.11 0-2 .9-2 2v4h2V5h14v14H5v-4H3v4c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z"></path></svg>
                  <span class="ml-2 text-sm">Não é você? sair</span>
                </a>
              </li>
            </ul>
          </div>
        </div>
      </transition>
    </div>
    <div v-else :class="dropdownOpened ? 'z-30' : 'z-0'" class="dropdown-nav relative py-4 h-full"  @click="dropDownClickHandler" @mouseenter="mouseenter" @mouseleave="mlAccountNotlogged">
      <a href="#" class="">
        <div class="flex items-center flex-row">
          <div class="rounded-full flex items-center justify-center border-2 w-10 h-10 border-white">
            <svg fill="currentColor" class="fill-current text-white inline-block h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20">
              <path class="heroicon-ui" d="M5 5a5 5 0 0 1 10 0v2A5 5 0 0 1 5 7V5zM0 16.68A19.9 19.9 0 0 1 10 14c3.64 0 7.06.97 10 2.68V20H0v-3.32z"/>
            </svg>
          </div>
          <div class="hidden lg:flex flex-row w-40 pl-2">
              <span class="text-sm font-light leading-tight text-left text-white">
                olá, faça seu login ou cadastre-se
              </span>
              <svg class="h-6 w-8 text-white" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor">
                <path d="M5.293 7.293a1 1 0 011.414 0L10 10.586l3.293-3.293a1 1 0 111.414 1.414l-4 4a1 1 0 01-1.414 0l-4-4a1 1 0 010-1.414z" clip-rule="evenodd" />
              </svg>
            </div>
          </div>
        </a>
        <transition name="fade">
        <div v-show="dropdownOpened" class="absolute dropdown-nav-content -ml-40 lg:ml-0 mt-4">
          <div class="absolute bg-white h-8 w-6 -mt-5 right-0 mr-6 bg-opacity-0">
            <svg fill="currentColor" class=" text-white h-4 right-0 top-full" x="0px" y="0px" viewBox="0 0 300 200" xml:space="preserve"><polygon class="fill-current stroke-0" points="150,0 300,200 0,200"/></svg>
          </div>
          <div class="normal-case font-normal xs:left-0 lg:right-0 p-2 bg-white overflow-hidden shadow w-56 -mt-1">
            <p class="text-gray-800 font-normal text-sm px-4 py-21">pra ver seus pedidos e ter uma experiência personalizada, acesse sua conta :)</p>
            <div class="px-4 mt-4">
            <nuxt-link :to="localePath({ path: '/login' })">
              <div class="bg-indigo-700 hover:bg-indigo-600 text-white w-full py-2 align-bottom bottom-0 rounded text-center">entrar</div>
            </nuxt-link>
            </div>
            <div class="my-2 text-center">
              <nuxt-link :to="localePath({ path: 'auth/register' })" class="text-gray-800 text-sm hover:text-indigo-600 hover:underline">cliente novo? cadastrar</nuxt-link>
            </div>
          </div>
        </div>
        </transition>
      </div>
  </div>
</template>

<script>
// import { mixin as clickaway } from 'vue-clickaway'
export default {
  // mixins: [ clickaway ],
  data() {
    return {
      isVisible: false,
      focusedIndex: 0,
      bgWrapper: null,
      MenuOptions: {
        logged: {

        }
      }
    }
  },

  watch: {
    dropdownOpened(value) {
      if (value == false) {
        if (!document.querySelector('.dropdown-nav-content').classList.contains('hidden')) return
          else document.querySelector('.dropdown-nav-content').classList.add('hidden')
      } else {
          document.querySelector('.dropdown-nav-content').classList.remove('hidden')
      }

      console.log(value)
    },
  },

  mounted() {
    this.bgWrapper = document.querySelector('.bg-wrapper')
  },

  computed: {
    openedNav: {
      get() {
        return this.$store.state.openedNav
      },
      set(value) {
        this.$store.commit('SET_OPENED_NAV', value)
      }
    },

    isMobile() {
      return this.$store.state.isMobile
    },

    dropdownOpened() {
      return this.openedNav.status && this.openedNav.element === document.querySelector('.dropdown-nav')
    }
  },
  methods: {
    async logout() {
      await this.$auth.logout()

      this.openedNav = {
        status: false
      }

      this.$router.push({ path: '/' })
    },

    dropDownClickHandler(e) {
      // e.stopPropagation();
      const dropdown = document.querySelector('.dropdown-nav-content')
      if (this.isMobile)
      {
        // e.target.parentNode = 50
        if (dropdown.classList.contains('hidden')) {
          dropdown.classList.remove('hidden')
        } else {
          dropdown.classList.add('hidden')
        }

          dropdown.classList.toggle('dropdown-effect')

          this.$store.dispatch('setOpenedNav', {
              element: document.querySelector('.dropdown-nav'),
              status: !this.$store.state.openedNav.status
            })
        }
    },

    mouseenter(e) {
      if (!this.isMobile) {
        // if (e.target.classList.contains('hidden')) {
        //   e.target.classList.remove('hidden')
          this.$store.dispatch('setOpenedNav', {
            element: e.target,
            status: true
          })

          // console.log(this.$store.state.openedNav)
          // e.target.nextElementSibling.style.opacity = 1
        // }
      }
    },

    mlAccountNotlogged(e) {
      if (!this.isMobile) {
        this.$store.dispatch('setOpenedNav', {
          element: document.querySelector('.dropdown-nav'),
          status: false
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>

  .fade-enter-active, .fade-leave-active {
    transition: all .15s ease-in-out;
  }
  .fade-enter, .fade-leave-to /* .fade-leave-active below version 2.1.8 */ {
    transform: translate(0px, 100px) rotate(0deg) !important;
    opacity: 0;
  }

@media (min-width: 720px){
  .dropdown-nav:hover > .dropdown-nav-content {
    display: flex;
    flex-direction: row;
    opacity: 1;
    z-index: 500;
    transform: translateY(0);
    -moz-transition: all .7s ease-in-out;
    -webkit-transition: all .7s ease-in-out;
    -ms-transition: all .7s ease-in-out;
    -o-transition: all .7s ease-in-out;
    transition: all .7s ease-in-out;
  }
}

</style>
